//+------------------------------------------------------------------+
//|                                                   Test_Limit.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//---
#define LIMIT_ORDERS (int)AccountInfoInteger(ACCOUNT_LIMIT_ORDERS)
#define VOLUME_MAX   SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX)
#define VOLUME_LIMIT SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_LIMIT)
//---
input double lot=1; // Lot
//+------------------------------------------------------------------+
//| _                                              |
//+------------------------------------------------------------------+
MqlTick lprc;
MqlRates rates[];
MqlTradeResult myresult;
MqlTradeRequest myrequest;
MqlTradeCheckResult mycheckresult;
MqlDateTime last_date;
//+------------------------------------------------------------------+
//| _                                           |
//+------------------------------------------------------------------+
#include <Trade/AccountInfo.mqh>
#include <Trade/SymbolInfo.mqh>
#include <Trade/HistoryOrderInfo.mqh>
#include <Trade/OrderInfo.mqh>
#include <Trade/DealInfo.mqh>
#include <Trade/PositionInfo.mqh>
#include <Trade/Trade.mqh>
//+------------------------------------------------------------------+
//| __                                     |
//+------------------------------------------------------------------+
CAccountInfo      myaccount;
CSymbolInfo       mysymbol;
CHistoryOrderInfo myhistoryorder;
COrderInfo        myorder;
CDealInfo         mydeal;
CPositionInfo     myposition;
CTrade            mytrade;

//+------------------------------------------------------------------+
//| _                                            |
//+------------------------------------------------------------------+
int spc=100;
int size=100;
double sum_ord_vol=0.0;
//---
int total_ord=0,ord_lmt=0;
bool isOrd=false,isPos = false;
//---
int dgt=0,spread=0,TRADE_EXEMODE=0,TRADE_CALC_MODE=0,Leverage=0;
//---
bool StopTrade_by_MaxDD=true;
double up_lvl=0.0,dw_lvl=0.0,fltr=0.0;
double max_eq=0.0,max_dd=0.0,dd_percent=0.0;
//---
double Lots=0.0,Contract_Size=0.0,vol_stp=0.0,vol_min=0.0,vol_max=0.0,vol_lmt=0.0;
double ask=0.0,bid=0.0,stp_lvl=0.0,pnt=0.0,tick_sz=0.0,tick_loss=0.0,tick_prft=0.0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   Set_Trading_Values_by_Symbols(_Symbol);
//---
   isPos=PositionSelect(_Symbol);
//---
   if(!isPos) //    
   //if(!isPos || isPos)
     {
      OpenPosition_LLM(lot,ORDER_TYPE_BUY,ask);
     }
   else //    
     {
      if(isOrd) { size+=spc; }
      //---
      double prc_pos=PositionGetDouble(POSITION_PRICE_OPEN);
      //---
      Set_Order(_Symbol,ORDER_TYPE_BUY_STOP,0,prc_pos+size*pnt,lot);
     }
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
   Get_Sum_VolumeOrders(sum_ord_vol);
//---
   PositionSelect(_Symbol);
//---
   Comment("--------------------------------------------------","\n",
           "ACCOUNT_LIMIT_ORDERS : "+IS(LIMIT_ORDERS),"\n",
           "SYMBOL_VOLUME_MAX : "+DS2(VOLUME_MAX),"\n",
           "SYMBOL_VOLUME_LIMIT : "+DS2(VOLUME_LIMIT),"\n",
           "--------------------------------------------------","\n",
           "CURRENT_VOLUME_POS : "+DS2(PositionGetDouble(POSITION_VOLUME)),"\n",
           "CURRENT_COUNT_ORDERS : "+IS(OrdersTotal()),"\n",
           "SUM_VOLUME_ORDERS : "+DS2(sum_ord_vol));
  }
//+------------------------------------------------------------------+
//| __ڨ_                              |
//+------------------------------------------------------------------+
void Get_Sum_VolumeOrders(double &lsum_ord_vol)
  {
   ulong ticket=0;
//---
   lsum_ord_vol=0.0;
//---
   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if((ticket=OrderGetTicket(i))>0)
        {
         lsum_ord_vol+=OrderGetDouble(ORDER_VOLUME_INITIAL);
        }
     }
  }
//+------------------------------------------------------------------+
//| ____                                |
//| _ڨ___                 |
//+------------------------------------------------------------------+
void OpenPosition_LLM(double lots,ENUM_ORDER_TYPE op_type,double op_prc)
  {
   uint retcode=NULL;
   string type_desc="";
//---
   ResetLastError();
//---
   mytrade.SetExpertMagicNumber(0); //      
   mytrade.SetDeviationInPoints(100); //     
//---
   if(mytrade.PositionOpen(_Symbol,op_type,lots,op_prc,0,0,"")) //   
     {
      retcode=mytrade.ResultRetcode();
      type_desc=mytrade.RequestActionDescription();
      //---
      if(retcode==10034) { Print(""+IS(retcode)+", "+ErrorDesc(retcode)+""); }
      //---
      Print("  : ["+type_desc+"]");
     }
   else //      ,   
     {
      retcode=mytrade.ResultRetcode();
      type_desc=mytrade.RequestActionDescription();
      //---        
      Print("    ["+type_desc+"]: "+IS(retcode)+", "+ErrorDesc(retcode)+"");
     }
  }
//+------------------------------------------------------------------+
//| __                                     |
//+------------------------------------------------------------------+
void Set_Order(string Symbol_,ENUM_ORDER_TYPE Type_Ord,double Price_limit,double Open_price,double Volume)
  {
   uint retcode=NULL;
   string type_desc="",s_ord_lmt="";
//---
   ResetLastError();
//---
   if(mytrade.OrderOpen(Symbol_,Type_Ord,Volume,Price_limit,Open_price,0,0,ORDER_TIME_GTC,0,""))
     {
      type_desc=mytrade.RequestActionDescription();
      //---
      if(retcode==10034) { Print(""+IS(retcode)+", "+ErrorDesc(retcode)+""); }
      //---
      Print(" ["+type_desc+"]  "); isOrd=true;
     }
   else
     {
      retcode=mytrade.ResultRetcode();
      type_desc=mytrade.RequestActionDescription();
      //---
      if(retcode==10033) { s_ord_lmt=" ("+IS((int)AccountInfoInteger(ACCOUNT_LIMIT_ORDERS))+")"; } else { s_ord_lmt=""; }
      //---
      Print("     ["+type_desc+"]: "+IS(retcode)+", "+ErrorDesc(retcode)+""+s_ord_lmt);
     }
  }
//+------------------------------------------------------------------+
//| _____ר         |
//+------------------------------------------------------------------+
//| [] -                                                       |
//+------------------------------------------------------------------+ 
void Set_Trading_Values_by_Symbols(string Symbol_)
  {
   ZeroTradingValues();
//---
   if(!SymbolInfoTick(Symbol_,lprc))
     { Print("   . "+IS(Error())+", "+ErrorDesc(Error())+""); }
//---
   stp_lvl=(int)SymbolInfoInteger(Symbol_,SYMBOL_TRADE_STOPS_LEVEL);
//---
   dgt=(int)SymbolInfoInteger(Symbol_,SYMBOL_DIGITS);
   pnt=SymbolInfoDouble(Symbol_,SYMBOL_POINT);
   spread=(int)SymbolInfoInteger(Symbol_,SYMBOL_SPREAD);
//---
   ask=ND_dgt(SymbolInfoDouble(Symbol_,SYMBOL_ASK),dgt);
   bid=ND_dgt(SymbolInfoDouble(Symbol_,SYMBOL_BID),dgt);
//---
   vol_stp=SymbolInfoDouble(Symbol_,SYMBOL_VOLUME_STEP);
   vol_min=SymbolInfoDouble(Symbol_,SYMBOL_VOLUME_MIN);
   vol_max=SymbolInfoDouble(Symbol_,SYMBOL_VOLUME_MAX);
   vol_lmt=SymbolInfoDouble(Symbol_,SYMBOL_VOLUME_LIMIT);
//---
   fltr=ND_dgt(vDgtMlt(3*pnt),dgt); up_lvl=ND_dgt(ask+stp_lvl*pnt,dgt); dw_lvl=ND_dgt(bid-stp_lvl*pnt,dgt);
//---
   Leverage=(int)AccountInfoInteger(ACCOUNT_LEVERAGE); //   
   Contract_Size=SymbolInfoDouble(Symbol_,SYMBOL_TRADE_CONTRACT_SIZE); //   
   TRADE_EXEMODE=(int)SymbolInfoInteger(Symbol_,SYMBOL_TRADE_EXEMODE); //    
   TRADE_CALC_MODE=(int)SymbolInfoInteger(Symbol_,SYMBOL_TRADE_CALC_MODE); //    
//---
   tick_sz=SymbolInfoDouble(Symbol_,SYMBOL_TRADE_TICK_SIZE); //   
   tick_loss=SymbolInfoDouble(Symbol_,SYMBOL_TRADE_TICK_VALUE_LOSS); //     
   tick_prft=SymbolInfoDouble(Symbol_,SYMBOL_TRADE_TICK_VALUE_PROFIT); //     
  }
//+------------------------------------------------------------------+
//| __                                      |
//+------------------------------------------------------------------+
void ZeroTradingValues()
  {
   ZeroMemory(stp_lvl);
//---
   ZeroMemory(dgt); ZeroMemory(pnt); ZeroMemory(spread);
//---
   ZeroMemory(ask); ZeroMemory(bid);
//---
   ZeroMemory(vol_min); ZeroMemory(vol_max); ZeroMemory(vol_lmt);
//---
   ZeroMemory(fltr); ZeroMemory(up_lvl); ZeroMemory(dw_lvl);
//---
   ZeroMemory(Leverage); ZeroMemory(Contract_Size); ZeroMemory(TRADE_EXEMODE); ZeroMemory(TRADE_CALC_MODE);
//---
   ZeroMemory(tick_sz); ZeroMemory(tick_loss); ZeroMemory(tick_prft);
  }
//+------------------------------------------------------------------+
//| ___                        |
//+------------------------------------------------------------------+
int Error()
  {
   return(GetLastError());
  }
//+------------------------------------------------------------------+
//| RETURN_ERROR_DESCRIPTION                                         |
//+------------------------------------------------------------------+
string ErrorDesc(int error_code)
  {
   string error_string;
//----
   switch(error_code)
     {
      //---    

      case 10004: error_string="";                                                         break;
      case 10006: error_string=" ";                                                break;
      case 10007: error_string="  ";                                        break;
      case 10008: error_string=" ";                                                  break;
      case 10009: error_string=" ";                                                break;
      case 10010: error_string="  ";                                       break;
      case 10011: error_string="  ";                                        break;
      case 10012: error_string="    ";                             break;
      case 10013: error_string=" ";                                             break;
      case 10014: error_string="   ";                                    break;
      case 10015: error_string="   ";                                     break;
      case 10016: error_string="   ";                                    break;
      case 10017: error_string=" ";                                              break;
      case 10018: error_string=" ";                                                    break;
      case 10019: error_string="   ";                                break;
      case 10020: error_string=" ";                                                 break;
      case 10021: error_string="    ";                     break;
      case 10022: error_string="     ";                        break;
      case 10023: error_string="  ";                                     break;
      case 10024: error_string="  ";                                          break;
      case 10025: error_string="   ";                                         break;
      case 10026: error_string="  ";                                 break;
      case 10027: error_string="   ";                     break;
      case 10028: error_string="   ";                               break;
      case 10029: error_string="   ";                                    break;
      case 10030: error_string="      ";        break;
      case 10031: error_string="    ";                              break;
      case 10032: error_string="     ";                   break;
      case 10033: error_string="     ";                break;
      case 10034: error_string="         ";  break;

      //---   

      case 0:  //   
      case 4001: error_string="  ";                                                                                                   break;
      case 4002: error_string="       ";                                                          break;
      case 4003: error_string="     ";                                                                                 break;
      case 4004: error_string="     ";                                                                            break;
      case 4005: error_string="    /   /     / ";                    break;
      case 4006: error_string="  ,       ";                                   break;
      case 4007: error_string="          ";                           break;
      case 4008: error_string="    ";                                                                                break;
      case 4009: error_string=" ";                                                                                                     break;
      case 4010: error_string="   / ";                                                                                        break;
      case 4011: error_string="    2 ";                                                                              break;
      case 4012: error_string=" ";                                                                                                             break;
      case 4013: error_string="  ";                                                                                                         break;
      case 4014: error_string="     ";                                                                                       break;
      //-- 
      case 4101: error_string="  ";                                                                                                 break;
      case 4102: error_string="  ";                                                                                                              break;
      case 4103: error_string="  ";                                                                                                                break;
      case 4104: error_string="   ,     ";                                                                       break;
      case 4105: error_string="  ";                                                                                                         break;
      case 4106: error_string="       ";                                                                              break;
      case 4107: error_string="   ";                                                                                                  break;
      case 4108: error_string="   ";                                                                                                     break;
      case 4109: error_string="   ";                                                                                        break;
      case 4110: error_string="   ";                                                                                                   break;
      case 4111: error_string="   ";                                                                                                     break;
      case 4112: error_string="   ";                                                                                                   break;
      case 4113: error_string=",   ,  ";                                                                             break;
      case 4114: error_string="     ";                                                                                      break;
      case 4115: error_string="     ";                                                                                        break;
      case 4116: error_string="     ";                                                                                        break;
      //--  
      case 4201: error_string="     ";                                                                                        break;
      case 4202: error_string="   ";                                                                                                    break;
      case 4203: error_string="    ";                                                                           break;
      case 4204: error_string="  ,  ";                                                                              break;
      case 4205: error_string="  ,  ";                                                                              break;
      //-- MarketInfo
      case 4301: error_string=" ";                                                                                                              break;
      case 4302: error_string="    MarketWatch";                                                                                                  break;
      case 4303: error_string="   ";                                                                                        break;
      case 4304: error_string="    (  )";                                                                                break;
      //--   
      case 4401: error_string="   !";                                                                                                break;
      case 4402: error_string="   ";                                                                                        break;
      //-- Global_Variables
      case 4501: error_string="     ";                                                                          break;
      case 4502: error_string="        ";                                                       break;
      case 4510: error_string="   ";                                                                                                     break;
      case 4511: error_string="   ";                                                                                                   break;
      case 4512: error_string="   ";                                                                                      break;
      case 4513: error_string="   ";                                                                                      break;
      case 4514: error_string="     ftp";                                                                                                break;
      //--   
      case 4601: error_string="     ";                                                                      break;
      case 4602: error_string="    ";                                                                                    break;
      //--   
      case 4603: error_string="    ";                                                                   break;
      //-- Account
      case 4701: error_string="   ";                                                                                          break;
      case 4751: error_string="   ";                                                                                       break;
      case 4752: error_string="   ";                                                                                                 break;
      case 4753: error_string="  ";                                                                                                              break;
      case 4754: error_string="  ";                                                                                                                 break;
      case 4755: error_string="  ";                                                                                                               break;
      case 4756: error_string="    ";                                                                                            break;
      //-- 
      case 4801: error_string=" ";                                                                                                              break;
      case 4802: error_string="    ";                                                                                                  break;
      case 4803: error_string="    ";                                                                                   break;
      case 4804: error_string="       ";                                                                           break;
      case 4805: error_string="   ";                                                                                                break;
      case 4806: error_string="   ";                                                                                                   break;
      case 4807: error_string="  ";                                                                                                      break;
      case 4808: error_string="     ";                                                                      break;
      case 4809: error_string="    ";                                                                                   break;
      case 4810: error_string="        ";                                                        break;
      case 4811: error_string="       ";                                                                    break;
      case 4812: error_string="    ";                                                                            break;
      //--  
      case 4901: error_string="     ";                                                                                               break;
      case 4902: error_string="     ";                                                                                                 break;
      case 4903: error_string="      ";                                                                                       break;
      case 4904: error_string="        ";                                                                       break;
      //--  
      case 5001: error_string="      64 ";                                                                              break;
      case 5002: error_string="  ";                                                                                                          break;
      case 5003: error_string="   ";                                                                                                       break;
      case 5004: error_string="  ";                                                                                                           break;
      case 5005: error_string="    ";                                                                                             break;
      case 5006: error_string="  ";                                                                                                           break;
      case 5007: error_string="      ,    ";                                                                  break;
      case 5008: error_string="  ";                                                                                                           break;
      case 5009: error_string="     ";                                                                                              break;
      case 5010: error_string="     ";                                                                                              break;
      case 5011: error_string="     ";                                                                                            break;
      case 5012: error_string="     ";                                                                                           break;
      case 5013: error_string="       CSV";                                                                                   break;
      case 5014: error_string="     CSV";                                                                                                 break;
      case 5015: error_string="  ";                                                                                                             break;
      case 5016: error_string="    ,      ";                                                              break;
      case 5017: error_string="      ,    ";                                                     break;
      case 5018: error_string="  ,  ";                                                                                                       break;
      case 5019: error_string="  ";                                                                                                              break;
      case 5020: error_string="    ";                                                                                                    break;
      case 5021: error_string="  ";                                                                                                        break;
      case 5022: error_string="  ";                                                                                                        break;
      case 5023: error_string=" ,   ";                                                                                                       break;
      case 5024: error_string="    ";                                                                                                break;
      case 5025: error_string="    (,          )";               break;
      //--  
      case 5030: error_string="   ";                                                                                                               break;
      case 5031: error_string="   ";                                                                                                         break;
      case 5032: error_string="   ";                                                                                                        break;
      case 5033: error_string="    ";                                                                                             break;
      case 5034: error_string="   ";                                                                                                  break;
      case 5035: error_string="  ,  ";                                                                                              break;
      case 5036: error_string="  , ,  ULONG_MAX";                                                                                    break;
      case 5037: error_string="  ";                                                                                                      break;
      case 5038: error_string="  ,  ";                                                                                 break;
      case 5039: error_string=" ,   ";                                                                                 break;
      case 5040: error_string="   string";                                                                                                break;
      case 5041: error_string="   ";                                                                                                     break;
      case 5042: error_string="    0,  ";                                                                                 break;
      case 5043: error_string="      ";                                                                                 break;
      case 5044: error_string="  ";                                                                                                       break;
      //--   
      case 5050: error_string="  .        ,      ";   break;
      case 5051: error_string="    AS_SERIES,    ";                                                             break;
      case 5052: error_string="  ,     ";                                                                break;
      case 5053: error_string="  ";                                                                                                            break;
      case 5054: error_string="   ";                                                                                                     break;
      case 5055: error_string="   ";                                                                                                   break;
      case 5056: error_string="    ";                                                                                            break;
      case 5057: error_string="    double";                                                                                                  break;
      case 5058: error_string="    float";                                                                                                   break;
      case 5059: error_string="    long";                                                                                                    break;
      case 5060: error_string="    int";                                                                                                     break;
      case 5061: error_string="    short";                                                                                                   break;
      case 5062: error_string="    char";                                                                                                    break;
      //--  

      default: error_string="  ";
     }
//----
   return(error_string);
  }
//+------------------------------------------------------------------+
//| __DATETIME__STRING___TIME_DATE             |
//+------------------------------------------------------------------+
string TSd(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE));
  }
//+------------------------------------------------------------------+
//| __DATETIME__STRING___TIME_MINUTES          |
//+------------------------------------------------------------------+
string TSm(datetime aValue)
  {
   return(TimeToString(aValue,TIME_MINUTES));
  }
//+------------------------------------------------------------------+
//| __DATETIME__STRING__                       |
//| TIME_MINUTES|TIME_SECONDS                                        |
//+------------------------------------------------------------------+
string TSms(datetime aValue)
  {
   return(TimeToString(aValue,TIME_MINUTES|TIME_SECONDS));
  }
//+------------------------------------------------------------------+
//| __DATETIME__STRING_                                |
//| __TIME_DATE|TIME_MINUTES                                 |
//+------------------------------------------------------------------+
string TSdm(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE|TIME_MINUTES));
  }
//+------------------------------------------------------------------+
//| __DATETIME__STRING_                                |
//| __TIME_DATE|TIME_MINUTES|TIME_SECONDS                    |
//+------------------------------------------------------------------+
string TSdms(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  }
//+------------------------------------------------------------------+
//| __INTEGER__STRING                                  |
//+------------------------------------------------------------------+
string IS(int aValue)
  {
   return(IntegerToString(aValue));
  }
//+------------------------------------------------------------------+
//| __DOUBLE__STRING                                   |
//+------------------------------------------------------------------+
string DS(double aValue,int amount)
  {
   return(DoubleToString(aValue,amount));
  }
//+------------------------------------------------------------------+
//| __DOUBLE__STRING___                   |
//+------------------------------------------------------------------+
string DS2(double aValue)
  {
   return(DoubleToString(aValue,2));
  }
//+------------------------------------------------------------------+
//| __DOUBLE__STRING__DIGITS_                  |
//+------------------------------------------------------------------+
string DS_dgt(double aValue,int digit)
  {
   return(DoubleToString(aValue,digit));
  }
//+------------------------------------------------------------------+
//| __STRING__INTEGER                                  |
//+------------------------------------------------------------------+
long SI(string aValue)
  {
   return(StringToInteger(aValue));
  }
//+------------------------------------------------------------------+
//| __STRING__DOUBLE                                   |
//+------------------------------------------------------------------+
double SD(string aValue)
  {
   return(StringToDouble(aValue));
  }
//+------------------------------------------------------------------+
//| ___                                     |
//+------------------------------------------------------------------+
double ND2(double aValue)
  {
   return(NormalizeDouble(aValue,2));
  }
//+------------------------------------------------------------------+
//| __DIGITS_                                    |
//+------------------------------------------------------------------+
double ND_dgt(double aValue,int digit)
  {
   return(NormalizeDouble(aValue,digit));
  }
//+------------------------------------------------------------------+
//| ______      |
//|                                                         |
//+------------------------------------------------------------------+
//| [] -  int                                                |
//+------------------------------------------------------------------+
int vDgtMlt(int value)
  {
   if(dgt==3 || dgt==5) { return(value*=10); } else { return(value); }
  }
//+------------------------------------------------------------------+
//| ______      |
//|                                                           |
//+------------------------------------------------------------------+
//| [] -  int                                                |
//+------------------------------------------------------------------+
int vDgtDvd(int value)
  {
   if(dgt==3 || dgt==5) { return(value/=10); } else { return(value); }
  }
//+------------------------------------------------------------------+
//| ______      |
//|                                                         |
//+------------------------------------------------------------------+
//| [] -  double                                             |
//+------------------------------------------------------------------+
double vDgtMlt(double value)
  {
   if(dgt==3 || dgt==5) { return(value*=10); } else { return(value); }
  }
//+------------------------------------------------------------------+
//| ______      |
//|                                                           |
//+------------------------------------------------------------------+
//| [] -  double                                             |
//+------------------------------------------------------------------+
double vDgtDvd(double value)
  {
   if(dgt==3 || dgt==5) { return(value/=10); } else { return(value); }
  }
//+------------------------------------------------------------------+
//| ____      |
//| _______           |
//+------------------------------------------------------------------+
//| [] -  double                                             |
//+------------------------------------------------------------------+
double vNDgtPnt(int value)
  {
   if(dgt==3 || dgt==5) { return(ND_dgt(value*pnt*10,dgt)); } else { return(ND_dgt(value*pnt,dgt)); }
  }
//+------------------------------------------------------------------+
